package bf;

import java.io.*;
import java.util.*;

public class ConfReader
{

   private static String confFile ="C:\\tomcats\\tomcat_1\\webapps\\ryhma10\\barfly.cff";

   private String SERVER_ADDRESS;
   private String DB_ADDRESS;
   private String DB_NAME;
   private String DB_USER;
   private String DB_PW;
   private String UPLOAD_DIR;

   private String BGTABLE, BGCOLOR, LINK, ALINK, VLINK;

   private static String [] attrib = new String [12];


   private static StringTokenizer row;
   private static String separator = "=";
   private static String temp = "";

   private static int i = 0;
   private static int index = 0;

   public static void readConfiguration() throws IOException
   {

      BufferedReader in = new BufferedReader( new FileReader(confFile) );

      temp = in.readLine();

      while( temp != null )
      {
		 if ( !temp.startsWith("#") && (temp.length() > 0) )
		 {
			 row = new StringTokenizer(temp, separator);
			 attrib[index] = row.nextToken();
			 attrib[index] = row.nextToken();
			 index++;
		 }

		 i++;
		 temp = in.readLine();
      }

      i=0;
      index=0;
      //return;
   }


   public static String getSERVER_ADDRESS()  {  return(attrib[0]);  }
   public static String getDB_ADDRESS()      {  return(attrib[1]);  }
   public static String getDB_NAME()         {  return(attrib[2]);  }
   public static String getDB_USER()         {  return(attrib[3]);  }
   public static String getDB_PW()           {  return(attrib[4]);  }
   public static String getUPLOAD_DIR()      {  return(attrib[5]);  }
   public static String getBGTABLE()         {  return(attrib[6]);  }
   public static String getBGCOLOR()         {  return(attrib[7]);  }
   public static String getLINK()            {  return(attrib[8]);  }
   public static String getALINK()           {  return(attrib[9]);  }
   public static String getVLINK()           {  return(attrib[10]);  }
   public static String getTEXT()            {  return(attrib[11]);  }

}

