package bf;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import org.apache.commons.fileupload.*;

public class UpdateBar extends HttpServlet {

  static final private String CONTENT_TYPE = "text/html";
  

  static final private String SERVER_ADDRESS = "http://10.20.42.138:8080/ryhma10/";
  static final private String DATABASE_ADDRESS = "10.20.42.138:3306";
  static final private String DB_USERNAME = "ryhma10";
  static final private String DB_PW = "ryh10";
  static final private String DB_NAME = "ryhma10";
  static final private String UPLOAD_DIR = "C:\\tomcats\\tomcat_1\\webapps\\ryhma10\\pics\\";

   
   /* 
   bf.ConfReader.readConfiguration();
  
   static final private String SERVER_ADDRESS = bf.ConfReader.getSERVER_ADDRESS();
   static final private String DATABASE_ADDRESS = bf.ConfReader.getDB_ADDRESS();
   static final private String DB_USERNAME = bf.ConfReader.getDB_USER();
   static final private String DB_PW = bf.ConfReader.getDB_PW();
   static final private String DB_NAME = bf.ConfReader.getDB_NAME();
   static final private String UPLOAD_DIR = bf.ConfReader.getUPLOAD_DIR();
   */
   
  public void init() throws ServletException {
  }
  public void doPost(HttpServletRequest request, HttpServletResponse response)
      throws ServletException, IOException {
          
    int index = 0;
    String fileName = "";
    String barName = "";
    String formParam[] = new String[11];
	//formParam[0] = address
	//formParam[1] = phone
	//formParam[2] = category
	//formParam[3] = open hours
	//formParam[4] = x coord
	//formParam[5] = y coord
	//formParam[6] = radius

    response.setContentType(CONTENT_TYPE);
    PrintWriter out = response.getWriter();
    out.println("<html>");
    out.println("<head><title>Upload</title></head>");
    out.println("<body>");
    out.println("<p>Updating...</p>");
    out.println("</body></html>");

    barName = request.getParameter("barname").toString();
	System.out.println("Barname" + barName);
	if (barName.length() < 1) {
      String codedURL = response.encodeURL(SERVER_ADDRESS + "login/updatebar.jsp?errorcode=emptyField");
      response.sendRedirect(codedURL);
      return;
    }
	

    if (FileUpload.isMultipartContent(request)) {
      DiskFileUpload fu = new DiskFileUpload();
      fu.setSizeMax(512000);
      fu.setSizeThreshold(512000);
      fu.setRepositoryPath(UPLOAD_DIR);

      List fileItems = null;
      try {
        fileItems = fu.parseRequest(request);
      } catch (FileUploadException ex) {
        ex.printStackTrace();
      }
      Iterator i = fileItems.iterator();
      while (i.hasNext()) {
        FileItem item = (FileItem)i.next();
        if (item.isFormField()) {
          //Normal form field
          String fieldValue = item.getString();
          if (fieldValue.equals("")) {
            //Form field was empty.
            String codedURL = response.encodeURL(SERVER_ADDRESS + "login/updatebar.jsp?errorcode=emptyField");
            response.sendRedirect(codedURL);
            return;
          }
          formParam[index] = item.getString();
		  
          index++;
        } else {
          //File upload
          fileName = item.getName();
          if (!fileName.equals("")) {
            //User have entered file name
            StringTokenizer st = new StringTokenizer(fileName, "\\");
            while (st.hasMoreTokens()) {
              fileName = st.nextToken();
            }
            FileOutputStream  fout = new FileOutputStream(UPLOAD_DIR+barName+"_"+fileName);
            fout.write(item.get());
            fout.flush();
            fout.close();
          }
        }
      }
    } else {
	  formParam[0] = request.getParameter("address");
      formParam[1] = request.getParameter("phone");
      formParam[2] = request.getParameter("category");
      formParam[3] = request.getParameter("openhours");
      formParam[4] = request.getParameter("x_coord");
      formParam[5] = request.getParameter("y_coord");
      formParam[6] = request.getParameter("radius");
      for (int i=0; i<6; i++) {
        if (formParam[i].equals("")) {
          String codedURL = response.encodeURL(SERVER_ADDRESS + "updatebar.jsp?errorcode=emptyField");
          response.sendRedirect(codedURL);
          return;
        }
      }
    }

    bf.mysqlhandler.openConnection(DB_NAME, DB_USERNAME, DB_PW, DATABASE_ADDRESS);
    try
	{
	  bf.mysqlhandler.modifyBar(barName, "", formParam[0], formParam[1], formParam[2],
          formParam[3], fileName, "No comments",
		  Double.parseDouble(formParam[4]),
		  Double.parseDouble(formParam[5]),
		  Double.parseDouble(formParam[6]));
	}
	catch(NumberFormatException e)
	{
	  response.sendRedirect("../login/updatebar.jsp?errorcode=screwYouToo");
	  return;
	}
    bf.mysqlhandler.closeConnection();
    String codedURL = response.encodeURL(SERVER_ADDRESS + "login/updatebar.jsp?errorcode=done");
    response.sendRedirect(codedURL);
    return;
  }

  //Clean up resources
  public void destroy() {
  }
}
