package bf;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import org.apache.commons.fileupload.*;

public class Upload extends HttpServlet {

  static final private String CONTENT_TYPE = "text/html";
  

  static final private String SERVER_ADDRESS = "http://10.20.42.138:8080/ryhma10/";
  static final private String DATABASE_ADDRESS = "10.20.42.138:3306";
  static final private String DB_USERNAME = "ryhma10";
  static final private String DB_PW = "ryh10";
  static final private String DB_NAME = "ryhma10";
  static final private String UPLOAD_DIR = "C:\\tomcats\\tomcat_1\\webapps\\ryhma10\\pics\\";

   
   /* 
   bf.ConfReader.readConfiguration();
  
   static final private String SERVER_ADDRESS = bf.ConfReader.getSERVER_ADDRESS();
   static final private String DATABASE_ADDRESS = bf.ConfReader.getDB_ADDRESS();
   static final private String DB_USERNAME = bf.ConfReader.getDB_USER();
   static final private String DB_PW = bf.ConfReader.getDB_PW();
   static final private String DB_NAME = bf.ConfReader.getDB_NAME();
   static final private String UPLOAD_DIR = bf.ConfReader.getUPLOAD_DIR();
   */
   
  public void init() throws ServletException {
  }
  public void doPost(HttpServletRequest request, HttpServletResponse response)
      throws ServletException, IOException {
	  
    int index = 0;
    int checkBoxValue = 0;
    String fileName = "";
    String userName = "";
    String formParam[] = new String[9];
    String requestType = request.getParameter("request_type");

    response.setContentType(CONTENT_TYPE);
    PrintWriter out = response.getWriter();
    out.println("<html>");
    out.println("<head><title>Upload</title></head>");
    out.println("<body>");
    out.println("<p>Updating...</p>");
    out.println("</body></html>");

    HttpSession sess = request.getSession();

    if( sess.getAttribute("name")!=null ) {
	userName = sess.getAttribute("name").toString();
    }

    if (FileUpload.isMultipartContent(request)) {
      DiskFileUpload fu = new DiskFileUpload();
      fu.setSizeMax(512000);
      fu.setSizeThreshold(512000);
      fu.setRepositoryPath(UPLOAD_DIR);

      List fileItems = null;
      try {
        fileItems = fu.parseRequest(request);
      } catch (FileUploadException ex) {
        ex.printStackTrace();
      }
      Iterator i = fileItems.iterator();
      while (i.hasNext()) {
        FileItem item = (FileItem)i.next();
        if (item.isFormField()) {
          //Normal form field
          String fieldValue = item.getString();
          if (fieldValue.equals("")) {
            //Form field was empty.
            if (requestType.equals("register")) {
              String codedURL = response.encodeURL(SERVER_ADDRESS + "register.jsp?empty_field=true");
              response.sendRedirect(codedURL);
              return;
            } else if (requestType.equals("update")) {
              String codedURL = response.encodeURL(SERVER_ADDRESS + "login/profile.jsp?update=empty_field");
              response.sendRedirect(codedURL);
              return;
            }
          }
          formParam[index] = item.getString();

          //Request from register page
          if (requestType.equals("register")) {
            if (index == 4) {
              //Check that password and verify password fields match.
              if (!this.checkPassword(formParam[3], formParam[4])) {
                String codedURL = response.encodeURL(SERVER_ADDRESS + "register.jsp?password_match=false");
                response.sendRedirect(codedURL);
                return;
              }
            } else if (index == 7) {
              //Check position tracking field.
              if (formParam[7].equals("yes")) {
                checkBoxValue = 1;
              }
            }
          }
          //Request from profile page
          else if (requestType.equals("update")) {
            if (index == 3) {
              //Check that password and verify password fields match.
              if (!this.checkPassword(formParam[2], formParam[3])) {
                String codedURL = response.encodeURL(SERVER_ADDRESS + "login/profile.jsp?password_match=false");
                response.sendRedirect(codedURL);
                return;
              }
            } else if (index == 6) {
              //Check position tracking field.
              if (formParam[6].equals("yes")) {
                checkBoxValue = 1;
              }
            }

          }
          index++;
        } else {
          //File upload
          fileName = item.getName();
          if (!fileName.equals("")) {
            //User have entered file name
            StringTokenizer st = new StringTokenizer(fileName, "\\");
            while (st.hasMoreTokens()) {
              fileName = st.nextToken();
            }
            if (userName.equals("")) {
              userName = formParam[2];
            }
            FileOutputStream  fout = new FileOutputStream(UPLOAD_DIR+userName+"_"+fileName);
            fout.write(item.get());
            fout.flush();
            fout.close();
          }
        }
      }
    } else {
      //Enumeration e = request.getParameterNames();
      //while (index < 9 /*e.hasMoreElements()*/) {
      //  String param = (String)e.nextElement();
      //  String val[] = request.getParameterValues(param);
      //  String fieldValue = "";
      //  for (int i=0; i<val.length; i++) {
      //    fieldValue += val[i];
      //  }
      if (requestType.equals("register")) {
	    formParam[0] = request.getParameter("firstname");
	  	formParam[1] = request.getParameter("lastname");
	  	formParam[2] = request.getParameter("username");
	    formParam[3] = request.getParameter("passwd1");
	    formParam[4] = request.getParameter("passwd2");
	    formParam[5] = request.getParameter("music");
	    formParam[6] = request.getParameter("song");
	    formParam[7] = request.getParameter("tracking");
		for (int i=0; i<7; i++) {
		  if (formParam[i].equals("")) {
            String codedURL = response.encodeURL(SERVER_ADDRESS + "register.jsp?empty_field=true");
            response.sendRedirect(codedURL);
            return;
		  }
		}

        if (!this.checkPassword(formParam[3], formParam[4])) {
          String codedURL = response.encodeURL(SERVER_ADDRESS + "register.jsp?password_match=false");
          response.sendRedirect(codedURL);
          return;
        }
        //Check position tracking field.
        if (formParam[7].equals("yes")) {
          checkBoxValue = 1;
        }
	  } else if (requestType.equals("update")) {
	    formParam[0] = request.getParameter("firstname");
	  	formParam[1] = request.getParameter("lastname");
	    formParam[2] = request.getParameter("passwd1");
	    formParam[3] = request.getParameter("passwd2");		
	    formParam[4] = request.getParameter("music");
	    formParam[5] = request.getParameter("song");
	    formParam[6] = request.getParameter("tracking");
		for (int i=0; i<7; i++) {
		  if (formParam[i].equals("")) {
            String codedURL = response.encodeURL(SERVER_ADDRESS + "login/profile.jsp?update=empty_field");
            response.sendRedirect(codedURL);
            return;
		  }
		}

        if (!this.checkPassword(formParam[2], formParam[3])) {
          String codedURL = response.encodeURL(SERVER_ADDRESS + "login/profile.jsp?password_match=false");
          response.sendRedirect(codedURL);
          return;
        }
        //Check position tracking field.
        if (formParam[6].equals("yes")) {
          checkBoxValue = 1;
        }
	  }	  
	  
    }
    if (request.getParameter("request_type") != null
        && request.getParameter("request_type").equals("update")) {

      bf.mysqlhandler.openConnection(DB_NAME, DB_USERNAME, DB_PW, DATABASE_ADDRESS);
      bf.mysqlhandler.modifyUser(formParam[0], formParam[1], userName, "",
          "", "", formParam[4], formParam[5], fileName, "", formParam[2], "",
          checkBoxValue);
      bf.mysqlhandler.closeConnection();
      String codedURL = response.encodeURL(SERVER_ADDRESS + "login/profile.jsp?update=done");
      response.sendRedirect(codedURL);
      //return;
    }
    else if (request.getParameter("request_type") != null
       && request.getParameter("request_type").equals("register")) {
      bf.mysqlhandler.openConnection(DB_NAME, DB_USERNAME, DB_PW, DATABASE_ADDRESS);
      String register = bf.mysqlhandler.newUser(formParam[0], formParam[1], formParam[2], "",
        "", "", formParam[5], formParam[6], fileName, "", formParam[3], "",
      checkBoxValue);
      bf.mysqlhandler.closeConnection();
      if (register.equals("New user registered succesfully")) {
	    String codedURL = response.encodeURL(SERVER_ADDRESS + "login.jsp?register=true");
        response.sendRedirect(codedURL);
        return;
      } else {
        String codedURL = response.encodeURL(SERVER_ADDRESS + "register.jsp?register_error=" + register);
        response.sendRedirect(codedURL);
        return;
      }
    }
  }

  public boolean checkPassword(String passwd, String verifyPassword) {
    if (passwd.equals(verifyPassword)) {
      return true;
    } else {
      return false;
    }
  }

  //Clean up resources
  public void destroy() {
  }
}
