package bf;

import java.sql.*;
import java.io.*;
import java.lang.Math.*;
import fi.oulu.mediateam.rotuaari.server.logging.*;

public class mysqlhandler {

static int connected;
static Connection conn;
static Statement stmt=null;

public static fi.oulu.mediateam.rotuaari.server.logging.RLogger logger = new fi.oulu.mediateam.rotuaari.server.logging.RLogger();

static String logbody;

//---------------------------------------------------------------------------------------------------
        
     public static String newBar(String name, String address, String phone, String category, String openhours, String logo, String comment, double xcrd, double ycrd, double r,String password) {
         ResultSet rs=null;
		 try 
            {
              if ((name==null) || (name=="")) return("You must enter a desired bar name");
              stmt = conn.createStatement();
              rs=stmt.executeQuery("SELECT name FROM bars WHERE name='"+name+"';");
              rs.last();
              int laskuri=rs.getRow();
              if (laskuri==0) 
              {
                stmt.executeUpdate("INSERT INTO bars VALUES('"+name+"','"+address+"','"+phone+"','"+category+"','"+openhours+"','"+logo+"','"+comment+"','"+xcrd+"','"+ycrd+"','"+r+"','"+password+"');");
                logbody = "<body><BarCreationEvent><BarName>" + name + "</BarName></BarCreationEvent></body>";
                logger.log(name,"BarFly","BarCreationEventv0.01",logbody);
			    System.out.println("Log send: \n" + logbody);
			    return("New bar registered succesfully");
              }
              else
              {
                rs.first();
                if (rs.getString(1).equalsIgnoreCase(name)) return("Bar '"+name+"' already exists. Please choose another name.");
                //if (rs.getString(2).equalsIgnoreCase(email)) return("Email address '"+email+"' is already in use. Only one user/email address allowed");
              }  
              
          }
          catch (SQLException ex) 
          {
            System.out.println("SQLException: " + ex.getMessage());
            System.out.println("SQLState: " + ex.getSQLState());
            System.out.println("VendorError: " + ex.getErrorCode());  
          }
          finally {
            if (rs!=null) { try { rs.close(); } catch (SQLException excp) {} rs = null; } 
            if (stmt!=null) { try { stmt.close(); }catch (SQLException excp) {} stmt = null; }
          } 
        
     return("Jokin mtt");
    }

//---------------------------------------------------------------------------------------------------
        
    public static void removeBar(String barname) {
		ResultSet rs=null;
	
		   try {
              stmt = conn.createStatement();
              stmt.executeUpdate("DELETE FROM bars WHERE name='"+barname+"';");
              logbody = "<body><BarRemoveEvent><BarName>" + barname + "</BarName></BarRemoveEvent></body>";
			  logger.log(barname,"BarFly","BarRemoveEventv0.01",logbody);
			  System.out.println("Log send: \n" + logbody);
		   }
           catch (SQLException ex) {
             System.out.println("SQLException: " + ex.getMessage());
             System.out.println("SQLState: " + ex.getSQLState());
             System.out.println("VendorError: " + ex.getErrorCode());  
           }
           finally { 
             if (rs!=null) { try { rs.close(); } catch (SQLException excp) {} rs = null; }
             if (stmt!=null) { try { stmt.close(); } catch (SQLException excp) {} stmt = null; }
           } 
    }  
     
//------------------------------------------------------------------------------------------------------
         
       public static void modifyBar(String name, String password, String address, String phone, String category, String openhours, String logo, String comment, double xcrd, double ycrd, double r) {
			ResultSet rs=null;
            int testi=0;
			
           try {
              stmt = conn.createStatement();
              rs=stmt.executeQuery("SELECT password FROM bars WHERE name='"+name+"';");
			  rs.last();
			  testi=rs.getRow();
			  if (testi > 0) {
			      rs.first();
				  //if (rs.getString(1).equals(password)) {
					  if (name!=null && name!="") stmt.executeUpdate("UPDATE bars SET name='"+name+"' WHERE name='"+name+"';");
					  if (address!=null && address!="") stmt.executeUpdate("UPDATE bars SET address='"+address+"' WHERE name='"+name+"';");
					  if (phone!=null && phone!="") stmt.executeUpdate("UPDATE bars SET phone='"+phone+"' WHERE name='"+name+"';");
					  if (category!=null && category!="") stmt.executeUpdate("UPDATE bars SET category='"+category+"' WHERE name='"+name+"';");
					  if (openhours!=null && openhours!="") stmt.executeUpdate("UPDATE bars SET openhours='"+openhours+"' WHERE name='"+name+"';");
					  if (logo!=null && logo!="") stmt.executeUpdate("UPDATE bars SET logo='"+logo+"' WHERE name='"+name+"';");
					  if (comment!=null && comment!="") stmt.executeUpdate("UPDATE bars SET comment='"+comment+"' WHERE name='"+name+"';");
					  stmt.executeUpdate("UPDATE bars SET xcoord='"+xcrd+"' WHERE name='"+name+"';");
					  stmt.executeUpdate("UPDATE bars SET ycoord='"+ycrd+"' WHERE name='"+name+"';");
					  stmt.executeUpdate("UPDATE bars SET r='"+r+"' WHERE name='"+name+"';");
					  logbody = "<body><BarModifyEvent><BarName>" + name + "</BarName><Address>" + address + "</Address><Phone>" + phone + "</Phone><Category>" + category + "</Category><Openhours>" + openhours + "</OpenHours><Logo>" + logo + "</Logo><Comment> " + comment + "</Comment></BarModifyEvent></body>";
					  logger.log(name,"BarFly","BarModifyEventv0.01",logbody);
					  System.out.println("Log send: \n" + logbody);
			      //}		  
				  //else System.out.println("Wrong password for bar modifying");
              }
			  else System.out.println("No such bar");
		   }   
           catch (SQLException ex) {
             System.out.println("SQLException: " + ex.getMessage());
             System.out.println("SQLState: " + ex.getSQLState());
             System.out.println("VendorError: " + ex.getErrorCode());  
           }
           finally { 
             if (rs!=null) { try { rs.close(); } catch (SQLException excp) {} rs = null; }
             if (stmt!=null) { try { stmt.close(); } catch (SQLException excp) {} stmt = null; }
           } 
        
        }
         
//------------------------------------------------------------------------------------------------------


        public static String newUser(String firstname, String lastname, String username, String sex, String address, String birth, String favmusic, String favsong, String logo, String comment, String password, String email, int tracking) {
            ResultSet rs=null;

			try
            {
              if ((username==null) || (username=="")) return("You must enter a desired username");
              //if (email==null) return("You must enter your email address");
              stmt = conn.createStatement();
              rs=stmt.executeQuery("select username from profiles where username='"+username+"';");
              rs.last();
              int testi=rs.getRow();
              if (testi==0)
              {
                stmt.executeUpdate("INSERT INTO profiles VALUES('"+firstname+"','"+lastname+"','"+username+"','"+sex+"','"+birth+"','"+favmusic+"','"+favsong+"','"+logo+"','"+comment+"','"+password+"','"+email+"','"+address+"','"+tracking+"');");
                stmt.executeUpdate("INSERT INTO variables VALUES('"+username+"',NULL,'','0','0','0','0');");
                logbody = "<body><UserCreationEvent><FirstName>" + firstname + "</FirstName><LastName>" + lastname + "</LastName><UserName>" + username + "</UserName></UserCreationEvent></body>";
				logger.log(username,"BarFly","UserCreationEventv0.01",logbody);
				System.out.println("Log send: \n" + logbody);
				return("New user registered succesfully");
              }
              else
              {
                rs.first();
                if (rs.getString(1).equalsIgnoreCase(username)) return("User '"+username+"' already exists. Please choose another name.");
                //if (rs.getString(2).equalsIgnoreCase(email)) return("Email address '"+email+"' is already in use. Only one user/email address allowed");
              }

          }
          catch (SQLException ex)
          {
            System.out.println("SQLException: " + ex.getMessage());
            System.out.println("SQLState: " + ex.getSQLState());
            System.out.println("VendorError: " + ex.getErrorCode());
          }
          finally {
            if (rs!=null) { try { rs.close(); } catch (SQLException excp) {} rs = null; }
            if (stmt!=null) { try { stmt.close(); }catch (SQLException excp) {} stmt = null; }
          }

     return("Jokin mtt");
    }


//---------------------------------------------------------------------------------------------------

         public static void saveLocation(String ip, double xcrd, double ycrd) {
			ResultSet rs=null;

           try {
              stmt = conn.createStatement();
              stmt.executeUpdate("UPDATE variables SET xcrd="+xcrd+", ycrd="+ycrd+" WHERE ip='"+ip+"';");
           }
           catch (SQLException ex) {
             System.out.println("SQLException: " + ex.getMessage());
             System.out.println("SQLState: " + ex.getSQLState());
             System.out.println("VendorError: " + ex.getErrorCode());
           }
           finally {
             if (rs!=null) { try { rs.close(); } catch (SQLException excp) {} rs = null; }
             if (stmt!=null) { try { stmt.close(); } catch (SQLException excp) {} stmt = null; }
           }

        }

//------------------------------------------------------------------------------------------------------
         public static boolean checkTrackable(String username) {
         int testi;
		 ResultSet rs=null;


			try {
              stmt = conn.createStatement();
              rs = stmt.executeQuery("SELECT tracking FROM profiles WHERE username='"+username+"';");
              rs.last();
              testi=rs.getRow();
              if (testi>0) {
                  rs.first();
                  if (rs.getInt(1) == 1) return true;
                  if (rs.getInt(1) == 0) return false;
              }
           }
           catch (SQLException ex) {
             System.out.println("SQLException: " + ex.getMessage());
             System.out.println("SQLState: " + ex.getSQLState());
             System.out.println("VendorError: " + ex.getErrorCode());
           }
           finally {
             if (rs!=null) { try { rs.close(); } catch (SQLException excp) {} rs = null; }
             if (stmt!=null) { try { stmt.close(); } catch (SQLException excp) {} stmt = null; }
           }

         return(false);


         }


//------------------------------------------------------------------------------------------------------

         public static void modifyUser(String firstname, String lastname, String username, String sex, String address, String birth, String favmusic, String favsong, String logo, String comment, String password, String email, int tracking) {
		   ResultSet rs=null;

           try {
              stmt = conn.createStatement();
              if (firstname!=null && firstname!="") stmt.executeUpdate("UPDATE profiles SET firstname='"+firstname+"' WHERE username='"+username+"';");
              if (lastname!=null && lastname!="") stmt.executeUpdate("UPDATE profiles SET lastname='"+lastname+"' WHERE username='"+username+"';");
              if (sex!=null && sex!="") stmt.executeUpdate("UPDATE profiles SET sex='"+sex+"' WHERE username='"+username+"';");
              if (address!=null && address!="") stmt.executeUpdate("UPDATE profiles SET address='"+address+"' WHERE username='"+username+"';");
              if (birth!=null && birth!="") stmt.executeUpdate("UPDATE profiles SET birthday='"+birth+"' WHERE username='"+username+"';");
              if (favmusic!=null && favmusic!="") stmt.executeUpdate("UPDATE profiles SET favmusic='"+favmusic+"' WHERE username='"+username+"';");
              if (favsong!=null && favsong!="") stmt.executeUpdate("UPDATE profiles SET favsong='"+favsong+"' WHERE username='"+username+"';");
              if (logo!=null && logo!="") stmt.executeUpdate("UPDATE profiles SET logo='"+logo+"' WHERE username='"+username+"';");
              if (comment!=null && comment!="") stmt.executeUpdate("UPDATE profiles SET comment='"+comment+"' WHERE username='"+username+"';");
              if (password!=null && password!="") stmt.executeUpdate("UPDATE profiles SET password='"+password+"' WHERE username='"+username+"';");
              if (email!=null && email!="") stmt.executeUpdate("UPDATE profiles SET email='"+email+"' WHERE username='"+username+"';");
              if (tracking!=2) stmt.executeUpdate("UPDATE profiles SET tracking='"+tracking+"' WHERE username='"+username+"';");
           
	      logbody = "<body><ModifyProfileEvent><Username>" + username + "</UserName><Firstname>" + firstname + "</FirstName><Lastname>" + lastname + "</LastName><sex>" + sex + "</sex><address>" + address + "</address><birth>" + birth + "</birth><favmusic>" + favmusic + "</favmusic><favsong>" + favsong + "</favsong><logo>" + logo + "</logo><comment>" + comment + "</comment><password>" + password + "</password><email>" + email + "</email></ModifyProfileEvent></body>";
	      logger.log(username,"BarFly","ModifyProfileEventv0.01",logbody);
	      System.out.println("Log send: \n" + logbody);
	   }
           catch (SQLException ex) {
             System.out.println("SQLException: " + ex.getMessage());
             System.out.println("SQLState: " + ex.getSQLState());
             System.out.println("VendorError: " + ex.getErrorCode());
           }
           finally {
             if (rs!=null) { try { rs.close(); } catch (SQLException excp) {} rs = null; }
             if (stmt!=null) { try { stmt.close(); } catch (SQLException excp) {} stmt = null; }
           }

        }


//------------------------------------------------------------------------------------------------------

         public static void removeUser(String username) {
			ResultSet rs=null;

           try {
              stmt = conn.createStatement();
              stmt.executeUpdate("DELETE FROM profiles WHERE username='"+username+"';");
              stmt.executeUpdate("DELETE FROM variables WHERE username='"+username+"';");
	      logbody = "<body><UserDestructionEvent><UserName>" + username + "</UserName></UserDestructionEvent></body>";	      	               
	      logger.log(username,"BarFly","UserDestructionEventv0.01",logbody);
	      System.out.println("Log send: \n" + logbody);
	   }
           catch (SQLException ex) {
             System.out.println("SQLException: " + ex.getMessage());
             System.out.println("SQLState: " + ex.getSQLState());
             System.out.println("VendorError: " + ex.getErrorCode());
           }
           finally {
             if (rs!=null) { try { rs.close(); } catch (SQLException excp) {} rs = null; }
             if (stmt!=null) { try { stmt.close(); } catch (SQLException excp) {} stmt = null; }
           }

        }

//-----------------------------------------------------------------------------------------------------------
         public static double[] getLocation(String ip) {
			ResultSet rs=null;

			int testi=0;
            double[] coord = new double[2];

            try {
              stmt = conn.createStatement();
              rs = stmt.executeQuery("SELECT xcrd, ycrd FROM variables WHERE ip='"+ip+"';");
              rs.last();
              System.out.println("Toimiiks t h?");
			  testi = rs.getRow();
              System.out.println(testi);
			  if (testi > 0) {
                  testi = 0;
                  rs.first();
                  coord[0]=rs.getDouble(1);
                  coord[1]=rs.getDouble(2);
                  System.out.println(coord[0] + " " +coord[1]);
				  return coord;
              }
              else { System.out.println("There's no user with ip: "+ip); }
           }
           catch (SQLException ex) {
             System.out.println("SQLException: " + ex.getMessage());
             System.out.println("SQLState: " + ex.getSQLState());
             System.out.println("VendorError: " + ex.getErrorCode());
           }
           finally {
             if (rs!=null) { try { rs.close(); } catch (SQLException excp) {} rs = null; }
             if (stmt!=null) { try { stmt.close(); } catch (SQLException excp) {} stmt = null; }
           }

        return coord;
        }



//-----------------------------------------------------------------------------------------------------------
        public static String[][] searchUser(String username) {
		ResultSet rs=null;

		String[][] taulukko = new String[100][10];
          int testi=-1;
          StringBuffer ret=new StringBuffer(500);

          try
          {
              stmt = conn.createStatement();
              rs = stmt.executeQuery("SELECT username, firstname, lastname, logo, favmusic, favsong, tracking FROM profiles WHERE username LIKE '%"+username+"%';");
              //if (rs!=null) System.out.println("Displaying results:\n");
              ResultSetMetaData rsmd = rs.getMetaData();
              int numberOfColumns = rsmd.getColumnCount();
              /*for (int i = 1; i <= numberOfColumns; i++)
              {
                String columnName = rsmd.getColumnName(i);
                ret.append(columnName + "," );
              }
              ret.append("\n");*/
              while (rs.next())
              {
                testi++;
                for (int i = 1; i <= numberOfColumns; i++)
                {
                  //ret.append(rsmd.getColumnName(i)+": ");
                  taulukko[testi][i-1]=rs.getString(i);
                  //ret.append(rs.getString(i));
                  //ret.append("\n");
                }
              }

          }
          catch (SQLException ex)
          {
            System.out.println("SQLException: " + ex.getMessage());
            System.out.println("SQLState: " + ex.getSQLState());
            System.out.println("VendorError: " + ex.getErrorCode());
          }
          finally {
              if (rs!=null) { try { rs.close(); } catch (SQLException excp) {} rs = null; }
              if (stmt!=null) { try { stmt.close(); } catch (SQLException excp) {} stmt = null; }
          }

    return(taulukko);
    }


//-----------------------------------------------------------------------------------------------------------

        public static String searchBar(String barname) {
			ResultSet rs=null;

		StringBuffer ret=new StringBuffer(500);
          try
          {
              stmt = conn.createStatement();
              rs = stmt.executeQuery("SELECT name AS Name, address as Address, phone as 'Phone Number',"+
                                     "category as Category, openhours as Open, logo as URL, comment as Comment,"+
									 "xcoord, ycoord, r "+
                                     "FROM bars WHERE name LIKE '%"+barname+"%';");
              if (rs!=null) System.out.println("Displaying results:\n");

              ResultSetMetaData rsmd = rs.getMetaData();
              int numberOfColumns = rsmd.getColumnCount();
              /*for (int i = 1; i <= numberOfColumns; i++)
              {
                String columnName = rsmd.getColumnName(i);
                ret.append(columnName + "," );
              }
              ret.append("\n");*/
              while (rs.next())
              {
                for (int i = 1; i <= numberOfColumns; i++)
                {
                  //ret.append(rsmd.getColumnName(i)+": ");
                  ret.append(rs.getString(i));
                  //ret.append("\n");
                  if(i<=numberOfColumns) { ret.append("#"); }
                  if(i==numberOfColumns) { ret.append("%"); }
                }
              }

          }
          catch (SQLException ex)
          {
            System.out.println("SQLException: " + ex.getMessage());
            System.out.println("SQLState: " + ex.getSQLState());
            System.out.println("VendorError: " + ex.getErrorCode());
          }
          finally {
              if (rs!=null) { try { rs.close(); } catch (SQLException excp) {} rs = null; }
              if (stmt!=null) { try { stmt.close(); } catch (SQLException excp) {} stmt = null; }
          }

    return(ret.toString());
    }
//-----------------------------------------------------------------------------------------------------

      public static String usersInBar(String barname) {
	ResultSet rs=null;

	StringBuffer ret=new StringBuffer(500);
          try
          {
              stmt = conn.createStatement();
              rs = stmt.executeQuery("SELECT username FROM variables WHERE bar='"+barname+"';");
              if (rs!=null) System.out.println("Displaying results:\n");

              ResultSetMetaData rsmd = rs.getMetaData();
              int numberOfColumns = rsmd.getColumnCount();
              while (rs.next())
              {
                for (int i = 1; i <= numberOfColumns; i++)
                {
                  if (checkTrackable(rs.getString(i)))
				  { 
				    ret.append("<a class=a href=./search.jsp?searchuser="+rs.getString(i)+">");
				    ret.append(rs.getString(i)+"</a>");
                    ret.append("<br/>");
				  }	
				}
              }

          }
          catch (SQLException ex)
          {
            System.out.println("SQLException: " + ex.getMessage());
            System.out.println("SQLState: " + ex.getSQLState());
            System.out.println("VendorError: " + ex.getErrorCode());
          }
          finally {
              if (rs!=null) { try { rs.close(); } catch (SQLException excp) {} rs = null; }
              if (stmt!=null) { try { stmt.close(); } catch (SQLException excp) {} stmt = null; }
          }

    return(ret.toString());
    }

//-----------------------------------------------------------------------------------------------------

      public static boolean loginUser(String username, String password, String ip) {
		ResultSet rs=null;
        
		try
          {
              stmt = conn.createStatement();
              //stmt.executeUpdate("UPDATE variables SET connected='0' WHERE username='"+username+"';");
              rs = stmt.executeQuery("SELECT profiles.username, profiles.password, variables.connected from profiles, variables WHERE profiles.username="+
                                     "'"+username+"';");
              if (rs!=null) System.out.println("Displaying results:\n");
              rs.last();
              int testi=rs.getRow();
              if (testi>0) {
                testi=0;
                rs.first();
                System.out.println(rs.getString(2));
                if ((rs.getString(1).equals(username)) && (rs.getString(2).equals(password)))
                {
                  System.out.println(rs.getString(3));
                  stmt.executeUpdate("UPDATE variables SET connected='1' WHERE username='"+username+"';");
                  stmt.executeUpdate("UPDATE variables SET ip='"+ip+"' WHERE username='"+username+"';");
                  logbody = "<body><UserLoginEvent><UserName>" + username + "</UserName><UserLoginEvent></body>";
		          logger.log(username,"BarFly","UserLoginEventv0.01",logbody);
	              System.out.println("Log send: \n" + logbody);
		          return(true);
                }
              }
              else
              {
                System.out.println("User '"+username+"' not found, check your typing");
                return(false);
              }
          }
          catch (SQLException ex) {
            System.out.println("SQLException: " + ex.getMessage());
            System.out.println("SQLState: " + ex.getSQLState());
            System.out.println("VendorError: " + ex.getErrorCode());
          }
          finally {
              if (rs!=null) { try { rs.close(); } catch (SQLException excp) {} rs = null; }
              if (stmt!=null) { try { stmt.close(); } catch (SQLException excp) {} stmt = null; }
          }
    System.out.println("You entered wrong password");
    return(false);
    }

//------------------------------------------------------------------------------------------------------

          public static void logoutUser(String username) {
			ResultSet rs=null;


			try
            {
                stmt = conn.createStatement();
                //stmt.executeUpdate("UPDATE variables SET connected='0' WHERE username='"+username+"';");
                stmt.executeUpdate("UPDATE variables SET connected='0' WHERE username='"+username+"';");
		        logbody = "<body><UserLogOutEvent><UserName>" + username + "</UserName><UserLogOutEvent></body>";
		        logger.log(username,"BarFly","UserLogOutEventv0.01",logbody);
	            System.out.println("Log send: \n" + logbody);
            }
            catch (SQLException ex) {
              System.out.println("SQLException: " + ex.getMessage());
              System.out.println("SQLState: " + ex.getSQLState());
              System.out.println("VendorError: " + ex.getErrorCode());
            }
            finally {
                if (rs!=null) { try { rs.close(); } catch (SQLException excp) {} rs = null; }
                if (stmt!=null) { try { stmt.close(); } catch (SQLException excp) {} stmt = null; }
            }
          }

//-----------------------------------------------------------------------------------------------------





      public static void openConnection(String db, String userName, String password, String dbAddress)  {
      //this method connects with the remote database

        String database ="jdbc:mysql://"+dbAddress+"/"+db+"?user="+userName+"&password="+password;

        System.out.println("***DB: Trying to open connection to the database \n");
        try {
            Class.forName("com.mysql.jdbc.Driver").newInstance();
            conn = DriverManager.getConnection(database);
        if (!conn.isClosed()) {
            System.out.println("***DB: Connected to database\n");
            connected=1;
        }

        }catch (Exception ex) {
            System.out.println("Exception: "+ex.getMessage()+"\n");
            System.out.println("Failed to connect to the database \n");
            connected=0;
        }

    }

//----------------------------------------------------------------------------------------------

    public static void closeConnection(){
    //this method closes the connection to remote database
        System.out.println("***DB: Closing connection to the database");
        try {
            if (!conn.isClosed()) conn.close();
        } catch (Exception ex) {}
    }
	
//-----------------------------------------------------------------------------------------------------
      
      public static void executeCommand(String command) {
      ResultSet rs=null;
  
      
	  try 
            {
                stmt = conn.createStatement();
                stmt.executeUpdate(command); 
            }
            catch (SQLException ex) {
              System.out.println("SQLException: " + ex.getMessage());
              System.out.println("SQLState: " + ex.getSQLState());
              System.out.println("VendorError: " + ex.getErrorCode());  
            }
            finally { 
                if (rs!=null) { try { rs.close(); } catch (SQLException excp) {} rs = null; }
                if (stmt!=null) { try { stmt.close(); } catch (SQLException excp) {} stmt = null; }
            } 
          
      
      }    

//-----------------------------------------------------------------------------------------------------

	public static String findClosestBar(String username) {
		ResultSet rs=null;
		int wasinbar=0, userinbar=0, index=0, i=1;
		double[] user_location= new double[2];
		double[][] bar_locations = new double[50][3];
		double ero=0, temp=0,closest=500;
		double barx,barxx,bary,baryy;
		String lastbar, closestbar;
				
		try 
		{
			 String userip = getUserIP(username);
			 user_location = getLocation(userip);
			 bar_locations = getBarLocations();
			 stmt = conn.createStatement();
			 rs=stmt.executeQuery("SELECT userinbar, bar FROM variables WHERE username='"+username+"';");
             rs.next();
			 wasinbar=rs.getInt(1);
			 lastbar=rs.getString(2);
			 while (bar_locations[i][0]!=0)
			 {
				ero=Math.pow((Math.abs((user_location[0] - bar_locations[i][0]))),2) + Math.pow((Math.abs((user_location[1] - bar_locations[i][1]))),2);
				temp=Math.sqrt(ero);
				System.out.println("Bar number "+i+" distance: "+temp);
				if (temp < closest) 
				{
					closest=temp;
				    index=i;
				}
				barx=bar_locations[i][0]-bar_locations[i][2];
				barxx=bar_locations[i][0]+bar_locations[i][2];
				bary=bar_locations[i][1]-bar_locations[i][2];
				baryy=bar_locations[i][1]+bar_locations[i][2];
				if ((user_location[0]>=barx) && (user_location[0]<=barxx) && (user_location[1]>=bary) && (user_location[1]<=baryy))
				{
			        userinbar=i;
				}
				i++;
		     }
			 rs=stmt.executeQuery("select name from bars where xcoord="+bar_locations[index][0]+" and ycoord="+bar_locations[index][1]+";");
			 rs.next();
			 closestbar=rs.getString(1).toString();
			 if (userinbar!=0) 
			 {
				 stmt.executeUpdate("UPDATE variables SET bar='"+closestbar+"' WHERE username='"+username+"';");
                 if (wasinbar==0) 
				 {
					 stmt.executeUpdate("UPDATE variables SET userinbar=1 WHERE username='"+username+"';");
					 logbody = "<body><UserEnteredBarEvent><Username>" + username + "</UserName><BarName>" + closestbar + "</BarName></UserEnteredBarEvent></body>";				
					 logger.log(username,"BarFly","UserEnteredBarEventv0.01",logbody);
					 System.out.println("Log send: \n" + logbody);
				 }
             }				 
             else 
			 {
				stmt.executeUpdate("UPDATE variables SET bar='Not in bar' WHERE username='"+username+"';");
			    if (wasinbar==1)
				{
			         stmt.executeUpdate("UPDATE variables SET userinbar=0 WHERE username='"+username+"';");
					 logbody = "<body><UserLeaveBarEvent><UserName>" + username + "</Username><BarName>" + lastbar + "</BarName></UserLeaveBarEvent></body>";
					 logger.log(username,"BarFly","UserLeaveBarEventv0.01",logbody);
					 System.out.println("Log send: \n" + logbody);
				}
			 }	
			 return(closestbar);
		}
		catch (SQLException ex) {
              System.out.println("SQLException: " + ex.getMessage());
              System.out.println("SQLState: " + ex.getSQLState());
              System.out.println("VendorError: " + ex.getErrorCode());  
        }
        finally { 
            if (rs!=null) { try { rs.close(); } catch (SQLException excp) {} rs = null; }
            if (stmt!=null) { try { stmt.close(); } catch (SQLException excp) {} stmt = null; }
        }
		
	return("No bars in your immediate vicinity");
	}

//---------------------------------------------------------------------------------------------------
 
 public static double[][] getBarLocations() {
		int testi=0;
		ResultSet rs=null;
		double[][] bar_locations = new double[50][3];
		
		try 
		{
			 stmt = conn.createStatement();
             rs = stmt.executeQuery("SELECT xcoord,ycoord,r FROM bars;");
			 ResultSetMetaData rsmd = rs.getMetaData();
             int numberOfColumns = rsmd.getColumnCount();
             while (rs.next())
              {
                testi++;
    			for (int i = 1; i <= numberOfColumns; i++)
                {
                  bar_locations[testi][i-1]=rs.getDouble(i);
                  System.out.println("Bar number "+testi+" "+bar_locations[testi][i-1]); 
				}
              }
			return(bar_locations);
		}
		catch (SQLException ex) {
              System.out.println("SQLException: " + ex.getMessage());
              System.out.println("SQLState: " + ex.getSQLState());
              System.out.println("VendorError: " + ex.getErrorCode());  
        }
        finally { 
            if (rs!=null) { try { rs.close(); } catch (SQLException excp) {} rs = null; }
            if (stmt!=null) { try { stmt.close(); } catch (SQLException excp) {} stmt = null; }
        }
		
	return null;
	}

//-------------------------------------------------------------------------------------------------------------
 
 public static String getUserIP(String username) {
		int testi=0;
		ResultSet rs=null;
		StringBuffer ret = new StringBuffer(20);
		
		try 
		{
			 stmt = conn.createStatement();
             rs = stmt.executeQuery("SELECT ip FROM variables WHERE username='"+username+"';");
			 rs.last();
			 testi=rs.getRow();
			 if (testi>0) {
				 testi=0;
				 ret.append(rs.getString(1));
				 return(ret.toString());
			 }	 
		}
		catch (SQLException ex) {
              System.out.println("SQLException: " + ex.getMessage());
              System.out.println("SQLState: " + ex.getSQLState());
              System.out.println("VendorError: " + ex.getErrorCode());  
        }
        finally { 
            if (rs!=null) { try { rs.close(); } catch (SQLException excp) {} rs = null; }
            if (stmt!=null) { try { stmt.close(); } catch (SQLException excp) {} stmt = null; }
        }
		
	return null;
	}
	  
//-------------------------------------------------------------------------------------------------------------

public static String getUserBar(String username) {
		int testi=0;
		ResultSet rs=null;
		StringBuffer ret = new StringBuffer(20);
		
		try 
		{
			 stmt = conn.createStatement();
             rs = stmt.executeQuery("SELECT bar FROM variables WHERE username='"+username+"';");
			 rs.last();
			 testi=rs.getRow();
			 if (testi>0) {
				 testi=0;
				 ret.append(rs.getString(1));
				 return(ret.toString());
			 }	 
		}
		catch (SQLException ex) {
              System.out.println("SQLException: " + ex.getMessage());
              System.out.println("SQLState: " + ex.getSQLState());
              System.out.println("VendorError: " + ex.getErrorCode());  
        }
        finally { 
            if (rs!=null) { try { rs.close(); } catch (SQLException excp) {} rs = null; }
            if (stmt!=null) { try { stmt.close(); } catch (SQLException excp) {} stmt = null; }
        }
		
	return null;
	}
//-------------------------------------------------------------------------------------------------------------
}
