<!-- LAST UPDATE: 07.01.2004 klo 11:45 -->
<!-- ***************************************************************** -->
<!-- PAGE INITIALIZATIONS											   -->
<!-- ***************************************************************** -->

<%@ page import="bf.mysqlhandler" %>
<%@ page import="javax.servlet.http.*" %>
<%@ page import="java.io.*" %>
<%@ page import="java.util.*" %>

<% 
   
   /*---- SETTING PARAMETERS ----*/
   HttpSession sess = request.getSession();
   bf.mysqlhandler.openConnection(sess.getAttribute("DB_NAME").toString(),
                                  sess.getAttribute("DB_USER").toString(),
								  sess.getAttribute("DB_PW").toString(),
								  sess.getAttribute("DB_ADDRESS").toString());
   String sessionID = sess.getId();
   Date accessed = new Date(sess.getLastAccessedTime());
   Date created = new Date(sess.getCreationTime());
   String tempName = sess.getAttribute("name").toString();
   String ipAddr = sess.getAttribute("ipAddr").toString();
   
   String BGTABLE = sess.getAttribute("BGTABLE").toString();
   String BGCOLOR = sess.getAttribute("BGCOLOR").toString();
   String LINK = sess.getAttribute("LINK").toString();
   String VLINK = sess.getAttribute("VLINK").toString();
   String ALINK = sess.getAttribute("ALINK").toString();
   String TEXT = sess.getAttribute("TEXT").toString();

   double [] location = new double [2];
   location = bf.mysqlhandler.getLocation(ipAddr);
  
   String lout = request.getParameter("logout");
   String XC = request.getParameter("XC");
   String YC = request.getParameter("YC");
      
   if ( (XC != null && YC != null) && (XC.length() > 0 && YC.length() > 0) )
   {
     double XX = 0;
	 double YY = 0;
	  
     try
	 {
	   XX = Double.parseDouble(XC);
	   YY = Double.parseDouble(YC);
	 }
	 catch(NumberFormatException e)
	 {
	   response.sendRedirect("./main.jsp");
	 }
     bf.mysqlhandler.saveLocation(ipAddr, XX, YY);
   }
   
   /*---- LOGOUT PART OF THE PAGE ----*/
     if ( lout == null )
	 {
	   lout = "";
	 }
     if ( lout.equals("true") && lout != null )
	 {
	   bf.Location.removeUser(ipAddr);
	   System.out.println(tempName);
	   bf.mysqlhandler.executeCommand("Update variables set bar=' ' where username='"+tempName+"';");
	   bf.mysqlhandler.logoutUser(tempName);
	   //bf.mysqlhandler.closeConnection();
     
	   sess.invalidate();
	   response.sendRedirect("./..");
	 } 

  
%>

<!-- ***************************************************************** -->
<!-- PAGE ITSELF BEGINS												   -->
<!-- ***************************************************************** -->

<html>

<head>

	<title>BarFly</title>

	<link rel="stylesheet" type="text/css" href="style.css">

</head>

<!-- ***************************************************************** -->

<body bgcolor=<%= BGCOLOR %> 
      text=<%= TEXT %>
      link=<%= LINK %> 
	  vlink=<%= VLINK %> 
	  alink=<%= ALINK %> 
	  bgProperties="fixed">

	<div align="center">

	<p>&nbsp;</p>

<!-- ***************************************************************** -->
	
	<table bgcolor=<%= BGTABLE %> width="80%" border="0" cellpadding="0" cellspacing="0">
		<tr>
			<td width="20%" align="center">
			<a class="A" href="./main.jsp">Mainpage</a>
			</td>

			<td width="20%" align="center">
			<a class="A" href="./search.jsp">Search</a>
			</td>

			<td width="20%" align="center">
			<a class="A" href="./profile.jsp">MyProfile</a>
			</td>

			<td width="20%" align="center">
			<a class="A" href="./help.jsp">Help</a>
			</td>

			<td width="20%" align="center">
			<a class="A" href="./main.jsp?logout=true">Logout</a>
			</td>

		</tr>
	</table>

<!-- ***************************************************************** -->

<table class="taulukkokehys" bgcolor=<%= BGTABLE %> width="80%" border="0" cellpadding="0" cellspacing="0">

   <tr>

     <blocquote>
       <td width="80%">
         &nbsp;<font class="violetitalic"> >> Loginstatus: User 
         <font class=error>[<%= tempName %>]</font>
         logged in </font>
       </td>

       <td width="20%" align="right">
         <font class="comment">BarFly ver. 0.0.1a &nbsp; </font>
       </td>
     </blocquote>

</tr>

</table>

<!-- ***************************************************************** -->

<table bgcolor=<%= BGTABLE %> width="80%" border="0" cellpadding="0" cellspacing="0">

   <tr>

     <td align="top">
       <blockquote>
         <br/>

         <% 
		    out.println("<font class=violetitalic> Welcome to barfly service, use menubar (above) to navigate</font><br/><br/><br/>");

	        out.println("<span class=comment>find closest bar to coordinates:</span><br/>");
	        out.println("<form action=main.jsp>");
			out.println("<span class=comment>X coord:<input type=text name=XC size=20 /></span><br/>");
	        out.println("<span class=comment>Y coord:<input type=text name=YC size=20 /></span><br/>");
			out.println("<input type=submit method=POST name=submit value=Find /></form>");		

			out.println("<p class=comment>Your current location information is: " + location[0] +"," + location[1] + "</p><br/>");
			
			if( XC != null && YC != null )
			{
			  out.println("<p class=comment>Closest bar to your given coordinates: <a class=b href=./search.jsp?searchbar=" + bf.mysqlhandler.findClosestBar(tempName) + ">"+bf.mysqlhandler.findClosestBar(tempName)+"</a></p><br/>");
			}
			if( XC == null || YC == null)
			{
			  out.println("<p class=comment>Closest bar to you: <a class=b href=./search.jsp?searchbar=" + bf.mysqlhandler.findClosestBar(tempName) + ">"+bf.mysqlhandler.findClosestBar(tempName)+"</a></p><br/>");
			}
            
			out.println("<p class=comment>Your current bar is: " + bf.mysqlhandler.getUserBar(tempName) +"</a></p><br/>");
			
			if(tempName.equals("Admin"))
			{
			   out.print("<br/><a class=a href=./addbar.jsp>------>To ADMIN pages</a><br/>");
			}
			/*---- CLOSING DATABASE CONNECTION ----*/
   			//bf.mysqlhandler.closeConnection();			
         %>
         <br/>
       </blockquote>
     </td>

   </tr>

</table>

</div>

</body>
</html>
