<!-- ***************************************************************** -->
<!-- PAGE INITIALIZATIONS                                                         -->
<!-- ***************************************************************** -->
<%@ page import="bf.mysqlhandler" %>
<%@ page import="javax.servlet.http.*" %>
<%@ page import="java.io.*" %>
<%@ page import="java.util.*" %>
<%
  HttpSession sess = request.getSession();

   String SERVER_ADDRESS = sess.getAttribute("SERVER_ADDRESS").toString();
   String DB_ADDRESS = sess.getAttribute("DB_ADDRESS").toString();
   String DB_NAME = sess.getAttribute("DB_NAME").toString();
   String DB_USER = sess.getAttribute("DB_USER").toString();
   String DB_PW = sess.getAttribute("DB_PW").toString();
  
   String BGTABLE = sess.getAttribute("BGTABLE").toString();
   String BGCOLOR = sess.getAttribute("BGCOLOR").toString();
   String LINK = sess.getAttribute("LINK").toString();
   String VLINK = sess.getAttribute("VLINK").toString();
   String ALINK = sess.getAttribute("ALINK").toString();
   String TEXT = sess.getAttribute("TEXT").toString();  
   String tempName = sess.getAttribute("name").toString();
  
  if(!tempName.equals("Admin"))
  {
     response.sendRedirect("./main.jsp");
  }
  
  String error = request.getParameter("errorcode");
  if(error == null)
  {
    error = "";
  }  

  //String update = request.getParameter("update");
  bf.mysqlhandler.openConnection(DB_NAME, DB_USER , DB_PW, DB_ADDRESS);
  String bars = bf.mysqlhandler.searchBar("%");
  String barInfo = "";
  String barInfo2[] = new String[20];
  for (int i=0; i<barInfo2.length; i++) {
    barInfo2[i] = "";
  }
  if (request.getParameter("barname") != null) {
    barInfo = bf.mysqlhandler.searchBar(request.getParameter("barname").toString());
	barInfo2 = barInfo.split("#");
	for (int i=0; i<barInfo2.length; i++) {
		System.out.println(i+" "+barInfo2[i]);
	}
  }
  
  if (request.getParameter("barToRemove") != null) {
    bf.mysqlhandler.removeBar(request.getParameter("barToRemove").toString());
	response.sendRedirect("./updatebar.jsp");
	}
  
  bf.mysqlhandler.closeConnection();
%>

<!-- ***************************************************************** -->
<!-- PAGE ITSELF BEGINS                                                           -->
<!-- ***************************************************************** -->

<html>
<head>
  <title>BarFly</title>
  <link rel="stylesheet" type="text/css" href="style.css">
</head>

<!-- ***************************************************************** -->

<body bgcolor=<%= BGCOLOR %> 
      text=<%= TEXT %>
      link=<%= LINK %> 
      vlink=<%= VLINK %> 
      alink=<%= ALINK %> 
      bgProperties="fixed">
          
  <div align="center">
  <p>&nbsp;</p>

<!-- ***************************************************************** -->
        <table bgcolor=<%= BGTABLE %> width="80%" border="0" cellpadding="0" cellspacing="0">
                <tr>
                        <td width="20%" align="center">
                        <a class="A" href="./main.jsp">Back to mainpage</a>
                        </td>
						
                        <td width="20%" align="center">
                        <a class="A" href="./addbar.jsp">AddBar</a>
                        </td>

                        <td width="20%" align="center">
                        <a class="A" href="./updatebar.jsp">ModifyBar</a>
                        </td>

                        <td width="20%" align="center">
                        <a class="A" href="./addbar.jsp"></a>
                        </td>

                        <td width="20%" align="center">
                        <a class="A" href="./help.jsp"></a>
                        </td>

                        <td width="20%" align="center">
                        <a class="A" href="./main.jsp?logout=true">Logout</a>
                        </td>

                </tr>
        </table>

<!-- ***************************************************************** -->

<table class="taulukkokehys" bgcolor=<%= BGTABLE %> width="80%" border="0" cellpadding="0" cellspacing="0">

   <tr>

     <blocquote>
       <td width="80%">
         &nbsp;<font class="violetitalic"> >> Loginstatus: User
         <font class=error>[<%= tempName %>]</font>
         logged in </font>
       </td>

       <td width="20%" align="right">
         <font class="comment">BarFly ver. 0.0.1a &nbsp; </font>
       </td>
     </blocquote>

</tr>

</table>

<!-- ***************************************************************** -->

<!-- ***************************************************************** -->


  <table bgcolor=<%= BGTABLE %> width="80%" border="0" cellpadding="0" cellspacing="0">
  <tr>
  <td align="left" width="50%">  
  <blockquote>
  <br/>
  <table bgcolor=<%= BGTABLE %> width="100%" border="0" cellpadding="0" cellspacing="0">
  <% 
	String [] tempBars = bars.split("%");
	for( int i = 0 ; i < tempBars.length ; i++ )
	{//----FOR
	  try
	  {//----TRY
	    StringTokenizer row = new StringTokenizer(tempBars[i], "#");
	    out.print("<tr>");
	    String tempBarname = row.nextToken();
	    out.print("<td><a class=a href=./updatebar.jsp?barname="+tempBarname+">"+tempBarname+"</a>");
		out.print("<a class=b href=./updatebar.jsp?barToRemove="+tempBarname+"> (remove) </a></td>");
	    out.print("</tr>");

	  }//----TRY
	  catch(NoSuchElementException e)
	  {
	    out.print("<tr><td><span class=cyanitalic>No results</span><td></tr>");
	  }		   
    }//----FOR
  %>
  <tr><td><br/><hr/><br/></td></tr>
  </table>
  <table bgcolor=<%= BGTABLE %> width="100%" border="0" cellpadding="0" cellspacing="0">
  
  <%if (error.equals("emptyField")) { %>
    <tr><td><font class=error>[ERROR]: No empty fields allowed</font><br/><br/></td></tr>
  <% } %>
  <%if (error.equals("done")) { %>
    <tr><td><font class=error>[INFO]: Update done</font><br/><br/></td></tr>
  <% } %>    
  <%if (error.equals("screwYouToo")) { %>
    <tr><td><font class=error>[ERROR]: Wrong type of coordinate value</font><br/><br/></td></tr>
  <% } %>    
  
  <form method="post" enctype="multipart/form-data" action=<%=SERVER_ADDRESS%>servlet/bf.UpdateBar?barname=<%=barInfo2[0]%>>

  <tr>
    <td><span class="cyanitalic">Bar name:</span></td>
    <td><input disabled type="text" name="barname" size="20" value="<%=barInfo2[0]%>" /></td>
  </tr>
  
  <tr>
    <td><span class="cyanitalic">Address:</span></td>
    <td><input type="text" name="address" size="20" value="<%=barInfo2[1]%>" /></td>
  </tr>
  
  <tr>
    <td><span class="cyanitalic">Phone:</span></td>
    <td><input type="text" name="phone" size="20" value="<%=barInfo2[2]%>" /></td>
  </tr>
  
  <tr>
    <td><span class="cyanitalic">Category:</span></td>
    <td>
	  <select name="category" size="1">
       <option value="nightlife" <%if (barInfo2[3].equals("nightlife")) {%> selected<% } %> >Nightlife</option>
        <option value="dancebar" <%if (barInfo2[3].equals("dancebar")) {%> selected<% } %> >Dancebar</option>
        <option value="ymca" <%if (barInfo2[3].equals("ymca")) {%> selected<% } %> >Ymca</option>
        <option value="finnishpop" <%if (barInfo2[3].equals("finnishpop")) {%> selected<% } %> >Finnish pop</option>
        <option value="unipop" <%if (barInfo2[3].equals("unipop")) {%> selected<% } %> >Uni pop</option>
      </select>
	</td>
	
  </tr>
  
  <tr>
    <td><span class="cyanitalic">Open hours:</span></td>
    <td><input type="text" name="openhours" size="20" value="<%=barInfo2[4]%>" /></td>
  </tr>

  <tr>
    <td><span class="cyanitalic">X coordinate:</span></td>
    <td><input type="text" name="x_coord" size="20" value="<%=barInfo2[7]%>" /></td>
  </tr>
  
  <tr>
    <td><span class="cyanitalic">Y coordinate:</span></td>
    <td><input type="text" name="y_coord" size="20" value="<%=barInfo2[8]%>" /></td>
  </tr>

  <tr>
    <td><span class="cyanitalic">Radius:</span></td>
    <td><input type="text" name="radius" size="20" value="<%=barInfo2[9]%>" /></td>
  </tr>
    
  <tr>
    <td><span class="cyanitalic">Picture/Logo (optional):*</span></td>
    <td> <input type=file size=20 name="fname"> </td>
  </tr>

  <tr>
    <td><br/><input type="submit" name="submit" value="Update" /><br/><br/></td>
  </tr>
  </form>  
  </table>
  
  <blockquote>
  </td>
  </tr>
    
  </table>


</div>

</body>

</html>
