<!-- ***************************************************************** -->
<!-- PAGE INITIALIZATIONS											   -->
<!-- ***************************************************************** -->

<%
   bf.ConfReader.readConfiguration();
   final String SERVER_ADDRESS = bf.ConfReader.getSERVER_ADDRESS();
   final String DB_ADDRESS = bf.ConfReader.getDB_ADDRESS();
   final String DB_NAME = bf.ConfReader.getDB_NAME(); 
   final String DB_USER = bf.ConfReader.getDB_USER();
   final String DB_PW = bf.ConfReader.getDB_PW();
   final String UPLOAD_DIR = bf.ConfReader.getUPLOAD_DIR();
   final String BGTABLE = bf.ConfReader.getBGTABLE();
   final String BGCOLOR = bf.ConfReader.getBGCOLOR();
   final String LINK = bf.ConfReader.getLINK();
   final String VLINK = bf.ConfReader.getVLINK();
   final String ALINK = bf.ConfReader.getALINK();
   final String TEXT = bf.ConfReader.getTEXT();

  //final String SERVER_ADDRESS = "http://10.20.42.138:8080/ryhma10/";
  String emptyField = request.getParameter("empty_field");
  String passwordMatch = request.getParameter("password_match");
  String registerError = request.getParameter("register_error");
%>

<!-- ***************************************************************** -->
<!-- PAGE ITSELF BEGINS												   -->
<!-- ***************************************************************** -->

<html>

<head>

	<title>BarFly</title>

	<link rel="stylesheet" type="text/css" href="style.css">

</head>

<!-- ***************************************************************** -->

<body bgcolor=<%= BGCOLOR %> 
      text=<%= TEXT %>
      link=<%= LINK %> 
	  vlink=<%= VLINK %> 
	  alink=<%= ALINK %> 
	  bgProperties="fixed">

	<div align="center">

	<p>&nbsp;</p>

<!-- ***************************************************************** -->

	<table bgcolor=<%= BGTABLE %> width="80%" border="0" cellpadding="0" cellspacing="0">
		<tr>
			<td width="20%" align="center">
			<a class="A" href="./login.jsp">Login</a>
			</td>

			<td width="20%" align="center">
			<a class="A" href="./register.jsp">Register</a>
			</td>

			<td width="20%" align="center"><p/></td>

			<td width="20%" align="center"><p/></td>

			<td width="20%" align="center">
			<a class="A" href="./help.jsp">Help</a>
			</td>

		</tr>
	</table>

<!-- ***************************************************************** -->

<table class="taulukkokehys" bgcolor=<%= BGTABLE %> width="80%" border="0" cellpadding="0" cellspacing="0">

   <tr>

     <blocquote>
       <td width="80%">
         &nbsp;<font class="violetitalic"> >> Loginstatus: User
         not logged in </font>
       </td>

       <td width="20%" align="right">
         <font class="comment">BarFly ver. 0.0.1a &nbsp; </font>
       </td>
     </blocquote>

</tr>

</table>

<!-- ***************************************************************** -->

  <table bgcolor=<%= BGTABLE %> width="80%" border="0" cellpadding="0" cellspacing="0">
    <tr>
      <td>
	    <blockquote>
		<br/><br/>
	    <span class="comment">* will be displayed in the service</span>
		
		</blockquote>
      </td>
    </tr>
  </table>

<!-- ***************************************************************** -->


  <!--table align="left" bgcolor="#330033" width="40%" border="0" cellpadding="5" cellspacing="0"-->
  <table bgcolor=<%= BGTABLE %> width="80%" border="0" cellpadding="0" cellspacing="0">
  <tr>
  <td align="left" width="50%">
  <blockquote>
  <br/>
  
  <%if (passwordMatch != null && passwordMatch.equals("false")) { %>
  <table bgcolor=<%= BGTABLE %> width="100%" border="0" cellpadding="0" cellspacing="0">
  <tr>
    <td><font class=error>[ERROR]: Password and verify password don't match</font><br/><br/></td>
  </tr>
  </table>
  <% } %>
  
  <%if (emptyField != null && emptyField.equals("true")) { %>
  <table bgcolor=<%= BGTABLE %> width="100%" border="0" cellpadding="0" cellspacing="0">
  <tr>
    <td><font class=error>[ERROR]: Fill all fields</font><br/><br/></td>
  </tr>
  </table>	
  <% } %>
  
  <%if (registerError != null) { %>
  <table bgcolor=<%= BGTABLE %> width="100%" border="0" cellpadding="0" cellspacing="0">
  <tr>
    <td><font class=error>[ERROR]:<%= registerError %></font><br/><br/></td>
  </tr>
  </table>
  <% } %>
  
  <table bgcolor=<%= BGTABLE %> width="100%" border="0" cellpadding="0" cellspacing="0">

  <form method="post" enctype="multipart/form-data" action=<%=
    response.encodeURL(SERVER_ADDRESS+"servlet/bf.Upload?request_type=register")%> >

  <tr>
    <td><span class="cyanitalic">First name:</span></td>
    <td><input type="text" name="firstname" size="20" /></td>
  </tr>

  <tr>
    <td><span class="cyanitalic">Last name:</span></td>
    <td><input type="text" name="lastname" size="20" /></td>
  </tr>

  <tr>
    <td><span class="cyanitalic">Username:*</span></td>
    <td><input type="text" name="username" size="20" /></td>
  </tr>

  <tr>
    <td><span class="cyanitalic">Password:</span></td>
    <td><input type="password" name="passwd1" size="20" /></td>
  </tr>

  <tr>
    <td><span class="cyanitalic">Retype password:</span></td>
    <td><input type="password" name="passwd2" size="20" /></td>
  </tr>

  <tr>
    <td><span class="cyanitalic">Favorite music:*</span></td>
    <td>
      <select name="music" size="1">
        <option value="rock">Rock</option>
        <option value="heavy">Heavy</option>
        <option value="classic">Classic</option>
        <option value="finnishpop">Finnish pop</option>
        <option value="unipop">Uni pop</option>
      </select>
    </td>
  </tr>

  <tr>
    <td><span class="cyanitalic">Favorite song:*</span></td>
    <td><input type="text" name="song" size="20" /></td>
  </tr>

  <tr>
    <td><span class="cyanitalic">Allow position tracking:*</span></td>
    <td>
      <select name="tracking" size="1">
        <option value="yes" selected>Yes</option>
        <option value="no">No</option>
      </select>
    </td>
  </tr>

  <tr>
    <td><span class="cyanitalic">Picture/Logo (optional):*</span></td>
    <td> <input type=file size=20 name="fname"> </td>
  </tr>

  <tr>
    <td><br/><input type="submit" name="submit" value="Register" /></td>
  </tr>

  </form>
  </table>
  <br/><br/>
  </blockquote>
  </td>

  <td align="left" width="50%">
  </td>
  </tr>
  </table>


</div>

</body>

</html>
