package bf;

import java.io.*;
import java.util.*;
import java.math.*;

public class BarPosition
{

   private static String positionFile = "C:\\tomcats\\tomcat_1\\webapps\\ryhma10\\barfly.pos";
   private static StringTokenizer row1, row2;
   private static String separator1 = "=";
   private static String separator2 = "%";
   private static String temp = "";

   //BARNAME=XCoord%YCoord%Radius
   private static String [] BarNames = new String [50];
   private static double [] XCoord   = new double [50];
   private static double [] YCoord   = new double [50];
   private static double [] Radius   = new double [50];

   private static String closestBar = "BAR not found, get to civilization FAST!!!!!, call: 0600-30081"; 
   private static int i = 0;
   private static int index = 0;

   
   public static String findClosestBar(double XC, double YC)
   {
      double dist1, dist2;
      
      dist1 = Math.sqrt( ((XCoord[i] - XC)*(XCoord[i] - XC))+((YCoord[i] - YC)*(YCoord[i] - YC)) );
      closestBar = BarNames[i];
      for ( i = 1; i < BarNames.length; i++)
      {
         if(BarNames[i] != null)
		 {  
		    dist2 = Math.sqrt( ((XCoord[i] - XC)*(XCoord[i] - XC))+((YCoord[i] - YC)*(YCoord[i] - YC)) );
			dist2 = dist2 - Radius[i];
			if( dist2 < dist1 )
			{
			   dist1 = dist2;
			   closestBar = BarNames[i];
			}//if
         }//if
      }//for
	  i = 0;
      return closestBar;
   }//met

                 


   public static void readPositionTable() throws IOException
   {

      BufferedReader in = new BufferedReader( new FileReader(positionFile) );

      temp = in.readLine();

      while( temp != null )
      {
		 if ( !temp.startsWith("#") && (temp.length() > 0) )
		 {
			 row1 = new StringTokenizer(temp, separator1);
                         BarNames[index] = row1.nextToken();
			 			 temp = row1.nextToken();
  
                         row2 = new StringTokenizer(temp, separator2);
                         XCoord[index] = Double.parseDouble(row2.nextToken());
	                     YCoord[index] = Double.parseDouble(row2.nextToken());
                         Radius[index] = Double.parseDouble(row2.nextToken());

                         index++;
		 }
		 temp = in.readLine();
      }
      index=0;
      //return;
   }

}


