package bf;

import java.io.*;
import java.lang.*;
import electric.registry.*;
import javax.servlet.*;
import java.util.Vector;

class GetLocation implements Runnable{

  fi.oulu.mediateam.rotuaari.datamodel.Location sijainti = null;
  String ipstring;
  double xkoordinaatti = 0, ykoordinaatti = 0;
  int index = 0;
  static volatile boolean TimeToDie = false;

//Constructor:
GetLocation(){
  }

public void run()
  {

System.out.println("Location: Running");  
Thread GetLocation = Thread.currentThread();

  try{
	
    //Creating Entitymanager (entityMan)
    System.out.println("Location: Connecting to EntityManager");
	fi.oulu.mediateam.rotuaari.server.EntityManager entityMan =
        (fi.oulu.mediateam.rotuaari.server.EntityManager)
        electric.registry.Registry.bind(
        "http://www.rotuaari.net:8004/rotuaari/entitymanager.wsdl",
        fi.oulu.mediateam.rotuaari.server.EntityManager.class);

    //Creating SessionManager (sm)
    	System.out.println("Location:  -Connected Connecting to SessionManager");
	fi.oulu.mediateam.rotuaari.server.session.SessionManager sessionMan =
        (fi.oulu.mediateam.rotuaari.server.session.SessionManager)
        electric.registry.Registry.bind(
        "http://www.rotuaari.net:8004/rotuaari/sessionmanager.wsdl",
        fi.oulu.mediateam.rotuaari.server.session.SessionManager.class);

    //Creating EkahauLocationManager (locationMan)
	System.out.println("Location:  -Connected Connecting to LocationManager");

    fi.oulu.mediateam.rotuaari.server.LocationManager locationMan =
        (fi.oulu.mediateam.rotuaari.server.LocationManager)
        electric.registry.Registry.bind(
        "http://www.rotuaari.net:8004/rotuaari/ekahaulocationmanager.wsdl",
        fi.oulu.mediateam.rotuaari.server.LocationManager.class);


    //Login
    String sessionID = sessionMan.login("barfly@sip.mediateam.oulu.fi","rotuaari");
	System.out.println("Location: -Connected. SessionID: " + sessionID);
    
	if(TimeToDie)System.out.println("Location: Kuolema tulee");
    while(!TimeToDie){

	System.out.println("Location: In da Loop");
	
      for(index = 0; index < Location.UserVector.size(); index++)
      {
	   	System.out.println("Location: Get Location");
        
		ipstring = (String)Location.UserVector.elementAt(index);
		System.out.println(ipstring);
        
		try{
          sijainti = locationMan.getLocation(ipstring,sessionID);
          xkoordinaatti = sijainti.getLatitude();
          System.out.println("Location: X-Koordinaatti:" + xkoordinaatti);
		  ykoordinaatti = sijainti.getLongitude();
          System.out.println("Location: Y-Koordinaatti:" + ykoordinaatti);
		  Location.dbUpdate(ipstring, xkoordinaatti, ykoordinaatti);
        }//try
        catch(Exception e){
          System.out.println("Location: error:" + e.getMessage());
          Location.dbUpdate(ipstring, 0, 0);
        }//catch

      }//for

      try{ Thread.sleep(10000);}

      catch(InterruptedException ie) {System.out.println("Location: kosh");}


    }//While

	System.out.println("Location: Logging out from SW-server");
    sessionMan.logout(sessionID);

  }//try

  catch(electric.registry.RegistryException re){
	System.out.println("Location: kosh");
    re.printStackTrace();

  }//catch RegistryException

  catch(fi.oulu.mediateam.rotuaari.datamodel.InvalidPasswordException ipe){

	System.out.println("Location: kosh");
    ipe.printStackTrace();

  }//catch InvalidPasswordException

  }//run

}//GetLocation

public class Location
{
  public static Vector UserVector = new Vector();

  public static void main(String[] args) throws IOException
  {
	System.out.println("Main started");
  }//main

  public static void addUser(String IP){

    boolean test = false;
    int lukumaara;

    lukumaara = UserVector.size();

    if(lukumaara == 0){
    GetLocation.TimeToDie = false;  
	GetLocation Locator = new GetLocation();
	System.out.println("Location: Thread started");
	new Thread(Locator).start();
	
    }//if

    test = UserVector.contains(IP);
    if (test == false) UserVector.addElement(IP);

	System.out.println("Location: User Added");

  }//addUser

  public static void removeUser(String IP){

    int lukumaara;

    UserVector.removeElement(IP);

    lukumaara = UserVector.size();
    if(lukumaara == 0) {
	
	System.out.println("Location: UserVector is EMPTY");	
	
	GetLocation.TimeToDie = true;
	}
	System.out.println("Location: User Removed");


  }//removeUser

  public static void dbUpdate(String IP, double xcoor, double ycoor){

    bf.mysqlhandler.openConnection("ryhma10","ryhma10","ryh10","10.20.42.138:3306");      
    System.out.println("Tietokantaan: " + IP + ", " + xcoor + ", " + ycoor + "\n");
    bf.mysqlhandler.saveLocation(IP, xcoor, ycoor);
    bf.mysqlhandler.closeConnection();

  }//dbUpdate

  public static void Disconnect(){

    GetLocation.TimeToDie = true;

  }//Disconnect

}//class
