<!-- LAST UPDATE: 08.01.2004 klo 20:45 -->
<!-- ***************************************************************** -->
<!-- PAGE INITIALIZATIONS							     			   -->
<!-- ***************************************************************** -->

<%@ page import="bf.mysqlhandler" %>
<%@ page import="javax.servlet.http.*" %>
<%@ page import="java.io.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.net.*" %>
 
   <!-- SETTING PARAMETERS -->
<% 
   bf.ConfReader.readConfiguration();
   final String SERVER_ADDRESS = bf.ConfReader.getSERVER_ADDRESS();
   final String DB_ADDRESS = bf.ConfReader.getDB_ADDRESS();
   final String DB_NAME = bf.ConfReader.getDB_NAME(); 
   final String DB_USER = bf.ConfReader.getDB_USER();
   final String DB_PW = bf.ConfReader.getDB_PW();
   final String UPLOAD_DIR = bf.ConfReader.getUPLOAD_DIR();
   final String BGTABLE = bf.ConfReader.getBGTABLE();
   final String BGCOLOR = bf.ConfReader.getBGCOLOR();
   final String LINK = bf.ConfReader.getLINK();
   final String VLINK = bf.ConfReader.getVLINK();
   final String ALINK = bf.ConfReader.getALINK();
   final String TEXT = bf.ConfReader.getTEXT();

   //System.out.println(DB_NAME);
   //System.out.println(DB_USER);
   //System.out.println(DB_PW);
   //System.out.println(DB_ADDRESS);
            
   bf.mysqlhandler.openConnection(DB_NAME,DB_USER,DB_PW,DB_ADDRESS);
   String IPAddress = request.getRemoteAddr().toString();
   String auth = request.getParameter("authorization");
   	  if(auth == null)
   	  {
   	    auth = "";
   	  }
   String reg = request.getParameter("register");
      if(reg == null)
	  {
	    reg = "";
      }
   String tempUser = request.getParameter("username");
   String tempPass = request.getParameter("password"); 
%>

   <!-- FINDING USERNAME & PASSWORD -->

<% 
   if(tempUser != null && tempPass != null)
   { //111
	 /*---- CHECKING USERNAME AND PASSWORD ----*/
	 boolean checked = bf.mysqlhandler.loginUser(tempUser, tempPass, IPAddress);
       if(checked)
	   { //222
         HttpSession sess = request.getSession(true);
		 System.out.println("***INFO: New session created: " + sess.getId());
 
         bf.Location.addUser(IPAddress);
		 
         sess.setAttribute("name", tempUser);
         sess.setAttribute("passwd", tempPass);
	     sess.setAttribute("ipAddr", IPAddress);
		 sess.setAttribute("SERVER_ADDRESS",SERVER_ADDRESS);
		 sess.setAttribute("DB_ADDRESS",DB_ADDRESS);
		 sess.setAttribute("DB_NAME",DB_NAME);
		 sess.setAttribute("DB_USER",DB_USER);
		 sess.setAttribute("DB_PW",DB_PW);
		 sess.setAttribute("UPLOAD_DIR",UPLOAD_DIR);
		 sess.setAttribute("BGTABLE",BGTABLE);
		 sess.setAttribute("BGCOLOR",BGCOLOR);
		 sess.setAttribute("LINK",LINK);
		 sess.setAttribute("VLINK",VLINK);
		 sess.setAttribute("ALINK",ALINK);
		 sess.setAttribute("TEXT",TEXT);	 
		 System.out.println("***INFO: Sessionattributes set... redirecting to main.jsp");
		 
         response.sendRedirect("./login/main.jsp");
	   } //222
	   else
	   { //222
	     response.sendRedirect("login.jsp?authorization=failed");
		 System.out.println("***ERROR: Authorization failure");
	   } //222
   } //111
%>
 
   <!-- CLOSING DATABASE CONNECTION -->
<%   
   bf.mysqlhandler.closeConnection();
%>

<!-- ***************************************************************** -->
<!-- PAGE ITSELF BEGINS												   -->
<!-- ***************************************************************** -->
<html>

<head>

	<title>BarFly</title>

	<meta name="Surtr" content="BarFly software userinterface Login">
	<meta name="keywords" content="JSP, JavaServer Pages, servlets">

	<link rel="stylesheet" type="text/css" href="style.css">

</head>

<!-- ***************************************************************** -->

<body bgcolor=<%= BGCOLOR %> 
      text=<%= TEXT %>
      link=<%= LINK %> 
	  vlink=<%= VLINK %> 
	  alink=<%= ALINK %> 
	  bgProperties="fixed">

	<div align="center">

	<p>&nbsp;</p>
	
<!-- ***************************************************************** -->	

	<table bgcolor=<%= BGTABLE %> width="80%" border="0" cellpadding="0" cellspacing="0">
		<tr>
			<td width="20%" align="center">
			<a class="A" href="./login.jsp">Login</a>
			</td>

			<td width="20%" align="center">
			<a class="A" href="./register.jsp">Register</a>
			</td>

			<td width="20%" align="center"><p/></td>

			<td width="20%" align="center"><p/></td>

			<td width="20%" align="center">
			<a class="A" href="./help.jsp">Help</a>
			</td>

		</tr>
	</table>

<!-- ***************************************************************** -->

	<table class="taulukkokehys" bgcolor=<%= BGTABLE %> width="80%" border="0" cellpadding="0" cellspacing="0">
		<tr>
		<blocquote>
			<td width="80%">
				&nbsp;<font class="violetitalic"> >> Loginstatus: Not logged in </font>
			</td>
			<td width="20%" align="right">
				<font class="comment">BarFly ver. 0.0.1a &nbsp; </font>
			</td>

		</blocquote>
		</tr>
	</table>

<!-- ***************************************************************** -->

<table bgcolor=<%= BGTABLE %> width="80%" border="0" cellpadding="0" cellspacing="0">

   <tr>

     <td align="top">
       <blockquote>
         <br/><br/>

         <p class="comment">
           Welcome to PanOulu BarFly service.
           If you are not yet registered, you can do it here:<br/>
           <a class="A" href="./register.jsp"> >> Register </a>
         </p>

         <hr/>

         <% if(auth.equals("failed"))
            {
              out.println("<font class=error>[ERROR]: Authorization Failed</font>");
            } 
         %>
		 
         <% if(reg.equals("true"))
            {
              out.println("<font class=error>[INFO]: Registration Successful, ready to Login</font>");
            } 
         %>		 
								
         <% out.print("<form action="+response.encodeURL("login.jsp")+" method=POST>"); %>
         <span class="cyanitalic">Username:</span><br/><br/>
         &nbsp;&nbsp;
		 <input type="text" name="username" size="20" /><br/><br/>

         <span class="cyanitalic">Password:</span><br/><br/>
         &nbsp;&nbsp;
		 <input type="password" name="password" size="20" /><br/><br/><br/>

         <input type="submit" name="submit" value="Login" /><br/><br/>
         </form>
         
		 <br/>
       </blockquote>
     </td>

   <tr>

</table>

</body>
</html>
