<!-- ***************************************************************** -->
<!-- PAGE INITIALIZATIONS											   -->
<!-- ***************************************************************** -->

<%
  HttpSession sess = request.getSession();

   String SERVER_ADDRESS = sess.getAttribute("SERVER_ADDRESS").toString();
   String DB_ADDRESS = sess.getAttribute("DB_ADDRESS").toString();
   String DB_NAME = sess.getAttribute("DB_NAME").toString();
   String DB_USER = sess.getAttribute("DB_USER").toString();
   String DB_PW = sess.getAttribute("DB_PW").toString();
  
   String BGTABLE = sess.getAttribute("BGTABLE").toString();
   String BGCOLOR = sess.getAttribute("BGCOLOR").toString();
   String LINK = sess.getAttribute("LINK").toString();
   String VLINK = sess.getAttribute("VLINK").toString();
   String ALINK = sess.getAttribute("ALINK").toString();
   String TEXT = sess.getAttribute("TEXT").toString();  
  
  String tempName = sess.getAttribute("name").toString();

  String update = request.getParameter("update");
  String passwordMatch = request.getParameter("password_match");
  String registerError = request.getParameter("register_error");
  String removeUser = request.getParameter("userToRemove");

  bf.mysqlhandler.openConnection(DB_NAME, DB_USER , DB_PW, DB_ADDRESS);
  String data[][] = bf.mysqlhandler.searchUser(tempName);
%>

<!-- ***************************************************************** -->
<!-- PAGE ITSELF BEGINS												   -->
<!-- ***************************************************************** -->

<html>
<head>
  <title>BarFly</title>
  <link rel="stylesheet" type="text/css" href="style.css">
</head>

<!-- ***************************************************************** -->

<body bgcolor=<%= BGCOLOR %> 
      text=<%= TEXT %>
      link=<%= LINK %> 
	  vlink=<%= VLINK %> 
	  alink=<%= ALINK %> 
	  bgProperties="fixed">
	  
  <div align="center">
  <p>&nbsp;</p>

<!-- ***************************************************************** -->
	<table bgcolor=<%= BGTABLE %> width="80%" border="0" cellpadding="0" cellspacing="0">
		<tr>
			<td width="20%" align="center">
			<a class="A" href="./main.jsp">Mainpage</a>
			</td>

			<td width="20%" align="center">
			<a class="A" href="./search.jsp">Search</a>
			</td>

			<td width="20%" align="center">
			<a class="A" href="./profile.jsp">MyProfile</a>
			</td>

			<td width="20%" align="center">
			<a class="A" href="./help.jsp">Help</a>
			</td>

			<td width="20%" align="center">
			<a class="A" href="./main.jsp?logout=true">Logout</a>
			</td>

		</tr>
	</table>

<!-- ***************************************************************** -->

<table class="taulukkokehys" bgcolor=<%= BGTABLE %> width="80%" border="0" cellpadding="0" cellspacing="0">

   <tr>

     <blocquote>
       <td width="80%">
         &nbsp;<font class="violetitalic"> >> Loginstatus: User
         <font class=error>[<%= tempName %>]</font>
         logged in </font>
       </td>

       <td width="20%" align="right">
         <font class="comment">BarFly ver. 0.0.1a &nbsp; </font>
       </td>
     </blocquote>

</tr>

</table>

<!-- ***************************************************************** -->

  <table bgcolor=<%= BGTABLE %> width="80%" border="0" cellpadding="5" cellspacing="0">
    <tr>
    <td><span class="cyanitalic">* will be displayed in the service</span></td>
    </tr>

  <%if (update != null && update.equals("done")) { %>
    <tr>
      <td><font class=error>[INFO]:User data changed</font><br/><br/></td>
    </tr>
   <% } %>

  <%if (update != null && update.equals("empty_field")) { %>
    <tr>
      <td><font class=error>[ERROR]:No empty fields allowed</font><br/><br/></td>
    </tr>
  <% } %>
  <%if (passwordMatch != null && passwordMatch.equals("false")) { %>
    <tr>
      <td><font class=error>[ERROR]: Password and verify password don't match</font><br/><br/></td>
    </tr>
  <% } %>
  <%if (removeUser != null && removeUser.equals(tempName)) {
    bf.mysqlhandler.removeUser(removeUser);
	sess.invalidate();
	response.sendRedirect("../index.jsp?userRemoved=true");
	return;
  } %>  
  </table>

<!-- ***************************************************************** -->

  <table bgcolor=<%= BGTABLE %> width="80%" border="0" cellpadding="0" cellspacing="0">
  <tr>
  <td align="left" width="50%">  
  <blockquote>
  <br/>
  
  <table bgcolor=<%= BGTABLE %> width="80%" border="0" cellpadding="0" cellspacing="0">
  <tr>
  <td><img height="70" src="<%=SERVER_ADDRESS+"pics/"+data[0][0]+"_"+data[0][3]%>" /><br/><br/></td>
  </tr>
  </table>
  
  <table bgcolor=<%= BGTABLE %> width="100%" border="0" cellpadding="0" cellspacing="0">
  
  <form method="post" enctype="multipart/form-data" action=<%=SERVER_ADDRESS%>servlet/bf.Upload?request_type=update>

  <tr>
    <td><span class="cyanitalic">First name:</span></td>
    <td><input type="text" name="firstname" size="20" value=<%=data[0][1]%> /></td>
  </tr>
  
  <tr>
    <td><span class="cyanitalic">Last name:</span></td>
    <td><input type="text" name="lastname" size="20" value=<%=data[0][2]%> /></td>
  </tr>
  
  <tr>
    <td><span class="cyanitalic">Username:*</span></td>
    <td><input disabled type="text" name="username" size="20" value=<%=data[0][0]%> /></td>
  </tr>
  
  <tr>
    <td><span class="cyanitalic">Password:</span></td>
    <td><input type="password" name="passwd1" size="20" /></td>
  </tr>
  
  <tr>
    <td><span class="cyanitalic">Retype password:</span></td>
    <td><input type="password" name="passwd2" size="20" /></td>
  </tr>
  
  <tr>
    <td><span class="cyanitalic">Favorite music:*</span></td>
    <td>
      <select name="music" size="1">
        <option value="rock" <%if (data[0][4].equals("rock")) {%> selected<% } %> >Rock</option>
        <option value="heavy" <%if (data[0][4].equals("heavy")) {%> selected<% } %> >Heavy</option>
        <option value="classic" <%if (data[0][4].equals("classic")) {%> selected<% } %> >Classic</option>
        <option value="finnishpop" <%if (data[0][4].equals("finnishpop")) {%> selected<% } %> >Finnish pop</option>
        <option value="unipop" <%if (data[0][4].equals("unipop")) {%> selected<% } %> >Uni pop</option>
      </select>
    </td>
  </tr>
  
  <tr>
    <td><span class="cyanitalic">Favorite song:*</span></td>
    <td><input type="text" name="song" size="20" value=<%=data[0][5]%> /></td>
  </tr>
  
  <tr>
    <td><span class="cyanitalic">Allow position tracking:*</span></td>
    <td>
      <select name="tracking" size="1">
        <option value="yes" <%if (data[0][6].equals("1")) { %> selected <% } %> >Yes</option>
        <option value="no" <%if (data[0][6].equals("0")) { %> selected <% } %> >No</option>
      </select>
    </td>
  </tr>
  
  <tr>
    <td><span class="cyanitalic">Picture/Logo (optional):*</span></td>
    <td><input type="file" size=20 name="fname"></td>
  </tr>
  
  <tr>
    <td><br/><input type="submit" name="submit" value="Change" /><br/><br/></td>
  </tr>
  </form>  
  <tr>
  <td>
    <%
      out.print("<a class=b href=./profile.jsp?userToRemove="+tempName+"><font color=red><u> (Remove yourself from Barfly) </u></font></a></td>");
      bf.mysqlhandler.closeConnection();
    %>
  </td>
  </tr>
  </table>
  
  <blockquote>
  </td>
  </tr>

  </table>


</div>

</body>

</html>
